// TestIO.c
//
//  Opens parallel port and tests I/O permissions
//

#include <stdio.h>
#include <windows.h>
#include <conio.h>

#pragma intrinsic(_inp, _outp)

char *device_name = "\\\\.\\PPORTIO1";  /* parallel port direct I/O device */

static int io_check(int port)
{
    _try {
        _inp((unsigned short)port);  // do "test" I/O read
        return 1;   // all OK
    } _except( EXCEPTION_EXECUTE_HANDLER ) {
        return 0;   // exception...return error
    }
}

int main(int argc, char **argv)
{
    int port;
    unsigned long buf[3];
    FILE *fd;

    // open parallel port
    fd = fopen(device_name, "r");
    if (!fd) {
        printf("oops! can't open %s\n", device_name);
        exit(1);
    }

    // read port parameters
    fread(buf, sizeof(unsigned long), 3, fd);
    printf("%s I/O base = 0x%x, span = %d ports, driver open count = %d\n",
           device_name, buf[0], buf[1], buf[2]);

    // see what I/O addresses we can access
    printf("scanning all I/O ports...\n");
    for (port = 0; port < 8*1024; ++port) {
        if (io_check(port)) {
            printf("  port 0x%03x open\n", port);
        }
    }
    printf("%d I/O ports checked (0x0000-0x%03x)\n", port, port-1);

    fclose(fd);
    return 0;
}
