#!/usr/local/bin/perl
#
#   perl sys2tbl.pl file.sys > file.h
#
select((select(STDERR), $| = 1)[0]);    # unbuffer output 

##$ego = $0; $ego =~ s/.*[\\\/]//;  $ego =~ s/\.exe$//i;

sub usage {
    print STDERR "usage: perl $0 [-d] [-code name] file.sys\n";
    exit 1;
}

$code = 'code';
$debug = 0;
while ($ARGV[0] =~ /^-/) {
    $opt = $ARGV[0]; shift;
    if ($opt eq '-d') {
        $debug = 1;
    } elsif ($opt eq '-code') {
        $code = $ARGV[0]; shift;
    } else {
        print STDERR "unknown option ($opt)!\n";
        exit 1;
    }
}

&usage if ($ARGV[0] eq '');
$filename = $ARGV[0]; shift;
&usage if ($ARGV[0] ne '');

open(F, "<$filename") || die "can't open $filename\n";
binmode(F);

###binmode(STDOUT); print $data; exit;

print "// Created from $filename\n";
print "unsigned char ".$code."[] = {";
while(read(F, $data, 14)) {
    print "," if ($total);
    $len = length($data);
    for ($i = 0; $i < $len; ++$i) {
        $ch = sprintf("0x%02x", unpack('C', substr($data, $i, 1)));
        print "," if ($i);
        print "\n    " if (($i % 14) == 0);
        print "$ch";
    }
    $total += $len;
}
print "\n};\n";
print STDERR "$total bytes read from $filename\n";

close(F);
exit 0;
